           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM5_Spc_Seq = DM4_Spc_def:

(*****************************************************************

         1. proves lemma for Spc <=F Seq
         2.
         3. 
         4. 

 *****************************************************************)

(*** Back0_Back1 ***)

lemma Back0_Back1[simp]:
  "LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
  IN (Back0 -> <TH0> |[CH0]| <VAR x> |[CH1]| Back1 -> <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)
done

(*** Eat0_Back1 ***)

lemma Eat0_Back1[simp]: 
  "~ ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (Eat0 -> <EAT0 x> |[CH0]| <VAR x> |[CH1]| Back1 -> <TH1>) 
      -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)
done

(*** Back0_Eat1 ***)

lemma Back0_Eat1[simp]: 
  "ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (Back0 -> <TH0> |[CH0]| <VAR x> |[CH1]| Eat1 -> <EAT1 x>) 
      -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)
done

(*** EAT0_Back1 ***)

lemma EAT0_Back1[simp]: 
  "~ ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef EAT0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (<EAT0 x> |[CH0]| <VAR x> |[CH1]| Back1 -> <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)
done

(*** Back0_EAT1 ***)

lemma Back0_EAT1[simp]:
  "ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_EAT1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (Back0 -> <TH0> |[CH0]| <VAR x> |[CH1]| <EAT1 x>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)
done

(*** Back0_TH1  ***)

declare SpcDef.simps [simp del]

lemma Back0_TH1[simp]:
  "LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR x> |[CH1]| <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)+
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (case_tac "ODD x")
apply (tactic {* csp_simp_del_tac "SpcDef.simps" 1 *})
done

(*** TH0_Back1  ***)

lemma TH0_Back1[simp]:
  "LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef IN (<TH0> |[CH0]| <VAR x> |[CH1]| Back1 -> <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)+
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (case_tac "ODD x")
apply (tactic {* csp_simp_del_tac "SpcDef.simps" 1 *})
done

(*** TH0_Eat1 ***)

lemma TH0_Eat1[simp]:
  "ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (<TH0> |[CH0]| <VAR x> |[CH1]| Eat1 -> <EAT1 x>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)
done

(*** Eat0_TH1 ***)

lemma Eat0_TH1[simp]:
  "~ ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (Eat0 -> <EAT0 x> |[CH0]| <VAR x> |[CH1]| <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)
done

(*** TH0_TH1 ***)

lemma TH0_TH1[simp]:
  "LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef IN (<TH0> |[CH0]| <VAR x> |[CH1]| <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule)

apply (case_tac "ODD x")
apply (tactic {* csp_simp_del_tac "SpcDef.simps" 1 *})
apply (case_tac "ODD x")
apply (tactic {* csp_simp_del_tac "SpcDef.simps" 1 *})
done

(*** Back0_TH0_TH1 ***)

lemma Back0_TH0_WR1[simp]:
  "ODD x
    ==> 
        LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
        LET SysDef 
        IN Back0 -> (<TH0> |[CH0]| <VAR (3 * x + 1)> |[CH1]| <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)+
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM (3 * x + 1)" in exI)
apply (simp)
done

(*** Back1_TH0_TH1 ***)

lemma Back1_TH0_WR1[simp]:
  "ODD x
    ==> 
        LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
        LET SysDef 
        IN Back1 -> (<TH0> |[CH0]| <VAR (3 * x + 1)> |[CH1]| <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)+
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM (3 * x + 1)" in exI)
apply (simp)
done

(*** Back0_WR1 ***)

lemma Back0_WR1[simp]:
  "ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (Back0 -> <TH0> |[CH0]| <VAR x> |[CH1]| WR1 (3 * x + 1) -> <TH1>) 
   -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (simp)+
done

(*** WR0_Back1 ***)

lemma WR0_Back1[simp]:
  "~ ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (WR0 (x div 2) -> <TH0> |[CH0]| <VAR x> |[CH1]| Back1 -> <TH1>) 
       -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
done

(*** TH0_WR1 ***)

lemma TH0_WR1[simp]:
  "ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (<TH0> |[CH0]| <VAR x> |[CH1]| WR1 (3 * x + 1) -> <TH1>) 
      -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule)
apply (rule)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (simp)+

apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (rule csp_Timeout_right)
apply (simp)+
done

(*** WR0_TH1 ***)

lemma WR0_TH1[simp]:
  "~ ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Sys) <=F 
   LET SysDef 
   IN (WR0 (x div 2) -> <TH0> |[CH0]| <VAR x> |[CH1]| <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
done

(*** EAT0_TH1 ***)

lemma EAT0_TH1[simp]:
  "~ ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef EAT0_TH1) By Spc_to_Sys) <=F 
   LET SysDef IN (<EAT0 x> |[CH0]| <VAR x> |[CH1]| <TH1>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
done

(*** TH0_EAT1 ***)

lemma TH0_EAT1[simp]:
  "ODD x
   ==> 
   LET SysDef IN (Rewrite (SpcDef TH0_EAT1) By Spc_to_Sys) <=F 
   LET SysDef IN (<TH0> |[CH0]| <VAR x> |[CH1]| <EAT1 x>) -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM x" in exI)
apply (simp)

apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})
done

(*********************************************************
                  ALL n. Spc <=F Sys n
 *********************************************************)

lemma check_Spc_Sys: "CHECK Spc <=F (Sys n) BY Spc_to_Sys"
apply (rule)
apply (simp_all add: Spc_def Sys_def)

(*** body ***)
apply (rule csp_Int_choice_left1)+
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)

apply (induct_tac C)
apply (auto)
done

(*********************************************************
                       Finally
 *********************************************************)

lemma Spc_ref_Seq: "Spc <=F Sys n"
apply (insert check_Spc_Sys[of n])
apply (simp add: csp_fp_induct)
done

end
